config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  mount Rswag::Ui::Engine => '/api-docs'
  mount Rswag::Api::Engine => '/api-docs'

  post '/informed_consent' => 'questionnaire#create_informed_consent'
  get '/klaar' => 'reward#index'
  post '/' => 'questionnaire#create'
  root to: 'token_authentication#show'
  resources :mentor_overview, only: [:index]
  resources :questionnaire, only: %i[index show create destroy], param: :uuid do
    collection do
      get 'preference/:uuid', to: 'questionnaire#preference', as: 'preference'
      get :interactive
      post :interactive_post
      post :interactive_render
      post :from_json
    end
  end
  resource :person, only: %i[edit update] do
    get 'unsubscribe'
  end
  resource :language, only: %i[show] do
    collection do
      post :change
    end
  end

  get 'o', to: 'one_time_response#show', as: 'one_time_response'

  # Admin panel
  scope path: :admin do
    get '/', to: 'admin#index', as: 'admin'
    get 'export', to: 'admin#export', as: 'admin_export'
    get 'preview_overview', to: 'admin#preview_overview', as: 'admin_preview_overview'
    get 'organization_overview', to: 'admin#organization_overview', as: 'admin_organization_overview'

    get 'person_export', to: 'admin#person_export', as: 'admin_person_export'
    get 'identifier_export', to: 'admin#identifier_export', as: 'admin_identifier_export'
    get 'protocol_subscription_export', to: 'admin#protocol_subscription_export', as: 'admin_protocol_subscription_export'
    get 'invitation_set_export', to: 'admin#invitation_set_export', as: 'admin_invitation_set_export'
    get 'protocol_transfer_export', to: 'admin#protocol_transfer_export', as: 'admin_protocol_transfer_export'
    get 'questionnaire_export/:id', to: 'admin#questionnaire_export', as: 'admin_questionnaire_export'
    get 'response_export/:id', to: 'admin#response_export', as: 'admin_response_export'
    get 'reward_export', to: 'admin#reward_export', as: 'admin_reward_export'
    get 'proof_of_participation_export', to: 'admin#proof_of_participation_export', as: 'admin_proof_of_participation_export'

    post 'preview', to: 'admin#preview', as: 'admin_preview'
    get 'preview', to: 'admin#preview', as: 'admin_preview_get'
    post 'preview_done', to: 'admin#preview_done', as: 'admin_preview_done'
    get '*path', to: 'admin#index'
  end

  # Static pages
  get 'disclaimer', to: 'static_pages#disclaimer', as: 'disclaimer'

  # Status
  get '/status' => 'status#show'

  namespace :api do
    namespace :v1 do


      # JWT APIs
      scope module: :jwt_api do
        resources :one_time_response, only: [:index, :show], param: :otr
        resources :questionnaire, only: [:index, :show, :create, :update], param: :key do
          resources :results, only: [] do
            collection do
              get :distribution
            end
          end
        end
        resources :response, only: [:show, :index, :create], param: :uuid do
          collection do
            get :completed
            get :all
          end
        end
        resources :auth_user, only: [:create]
        resources :people, only: [:create] do
          collection do
            get :list_children
          end
          member do
            put :update_child
            delete :destroy_child
          end
        end

        resources :protocol_subscriptions, only: [] do
          collection do
            # @note Watch out! This can be interpreted as a show route later.
            get :mine # just retrieves active protocol subscriptions that are filled out "for myself"
            get :my_active_and_inactive
          end
        end
        resources :protocol, only: [:index] do
          member do
            post :preview
          end
        end
      end

      # JWT and Cookie apis
      # TODO in V2 API, rename to people.
      scope module: :cookie_and_jwt_api do
        resources :protocol_subscriptions, only: [:create, :show, :destroy]

        resources :person, only: [] do
          collection do
            get :me
            get :my_students
            put :update
            delete :destroy
          end
        end
      end

      # Basic auth APIs
      namespace :basic_auth_api do
        resources :scheduling, only: [] do
          collection do
            post :daily_at_one_am
            post :daily_at_two_am
            post :daily_at_three_am
            post :daily_at_four_am
            post :daily
            post :hourly
            post :thirty_minutely
            post :five_minutely
            post :minutely
          end
        end

        resources :protocols, only: %i[create]

        resources :protocol_subscriptions, only: [:create, :destroy, :update] do
          collection do
            get :delegated_protocol_subscriptions
            delete :destroy_delegated_protocol_subscriptions
          end
        end
        resources :person, only: %i[create update destroy] do
          collection do
            get :show_list
          end
          member do
            post :change_to_mentor
          end
        end

        resources :questionnaires, only: [:create, :show]
      end

      # Admin APIs
      namespace :admin do
        resources :team, only: [:show], param: :group
        resources :organization, only: [:show], param: :group
      end

      # Public APIs
      resources :statistics, only: [:index]
      resources :settings, only: [:index]
    end
  end
  match '/',
        controller: 'application',
        action: 'options',
        constraints: { method: %w[OPTIONS POST PUT PATCH DELETE] },
        via: %i[options post put patch delete]
  match '*path', via: :all, to: 'application#page_not_found'
end

app/controllers/mentor_overview_controller.rb
# frozen_string_literal: true

class MentorOverviewController < ApplicationController
  include ::IsLoggedIn
  include ::IsLoggedInAsMentor
  before_action :use_mentor_layout

  def index
    # @my_protocol_subscriptions is currently not used for mentors
    @my_protocol_subscriptions = current_user.my_protocols
    @student_protocol_subscriptions = current_user.my_protocols(false)
  end

  private

  def use_mentor_layout
    @use_mentor_layout = true
  end
end

app/views/mentor_overview/_participant_overview.html.haml
%div
  - student = protocol_subscription.filling_out_for
  - open_responses = protocol_subscription.responses.opened.reject{|resp| resp.expired?}
  - student_prot_id = protocol_subscription.filling_out_for.protocol_subscriptions.first&.id
  %li.collection-item.avatar{:style => "min-height:65px"}
    - if open_responses.blank?
      %i.large.material-icons.circle.green.lighten-2 done
      %span.title= "#{student.first_name} #{student.last_name}"
    - else
      %i.large.material-icons.circle.orange.lighten-2 perm_identity
      %span.title= "#{student.first_name} #{student.last_name}"
      %p
        - open_responses.each do |response|
          = link_to('Vragenlijst invullen voor deze student',
            questionnaire_path(uuid: response.uuid))
    - if student_prot_id
      :javascript
        start_overview_generation(#{student_prot_id})
      .graph{:id => "container_#{student_prot_id}"}
        .progress
          .indeterminate

app/views/mentor_overview/index.html.haml
= render partial: 'shared/header'
:javascript
  window.onbeforeunload = null;
%h2 Webapp Begeleiders
%p
  Voor
  %i
    = current_user.first_name
    = current_user.last_name

- if Time.zone.now < Time.new(2018, 10, 1).in_time_zone && current_user.protocol_subscriptions.active.count.positive?
  .row.section
    .col.s12= UnsubscribeGenerator.new.generate({ type: :unsubscribe,
                                  title: 'Klaar met dit schooljaar?',
                                  content: 'Ben je klaar met dit schooljaar? Klik dan op de knop \'Onderzoek afronden\' om het onderzoek te voltooien. Zo nee, vul dan gewoon de onderstaande vragenlijsten in.',
                                  button_text: 'Onderzoek afronden',
                                  unsubscribe_url: '/person/unsubscribe',
                                  data_method: 'get' })

.row.section
  .col.s12
    - if @student_protocol_subscriptions.blank?
      %p.flow-text Je begeleidt op dit moment geen studenten in #{ENV['PROJECT_NAME']}.
    - else
      %ul.collection
        - @student_protocol_subscriptions.each do |protocol_subscription|
          = render partial: 'participant_overview', locals: { protocol_subscription: protocol_subscription }

%footer
  .div.container
  %ul
    %li
      = link_to('Disclaimer', disclaimer_path)
    -#%li
      -#= link_to('Gegevens aanpassen', edit_person_path)

= render 'shared/feedback_button'